
local function bxor(a,b)
   local r = 0
   for i = 0, 31 do
      if ( a % 2 + b % 2 == 1 ) then
         r = r + 2^i
      end
      a = a / 2
      b = b / 2
   end
   return r
end

local function getTime()
sntp.sync('192.168.0.1',
  function(sec,usec,server)
    print('sync', sec, usec, server)
  end,
  function()
   print('failed!')
  end
)
end

--- Get temperature from DS18B20 
function getTemp()
      addr = ow.reset_search(DS18B20_pin)
      repeat
        tmr.wdclr()
      
      if (addr ~= nil) then
        crc = ow.crc8(string.sub(addr,1,7))
        if (crc == addr:byte(8)) then
          if ((addr:byte(1) == 0x10) or (addr:byte(1) == 0x28)) then
                ow.reset(DS18B20_pin)
                ow.select(DS18B20_pin, addr)
                ow.write(DS18B20_pin, 0x44, 1)
                tmr.delay(1000000)
                present = ow.reset(DS18B20_pin)
                ow.select(DS18B20_pin, addr)
                ow.write(DS18B20_pin,0xBE, 1)
                data = nil
                data = string.char(ow.read(DS18B20_pin))
                for i = 1, 8 do
                  data = data .. string.char(ow.read(DS18B20_pin))
                end
                crc = ow.crc8(string.sub(data,1,8))
                if (crc == data:byte(9)) then
                  t = (data:byte(1) + data:byte(2) * 256)
                  if (t > 32768) then
                    t = (bxor(t, 0xffff)) + 1
                    t = (-1) * t
                  end
                  t = t * 62
                  lasttemp = (t+500)/1000
                  -- lasttemp = ((t/1000)-((t/1000)%1)) /10
                  -- print (lasttemp .. ' °C')
                  return (lasttemp .. ' °C')
                end                   
                tmr.wdclr()
          end
        end
      end
      addr = ow.search(DS18B20_pin)
      until(addr == nil)
end

local function pushTheButton(connection, pin)
   -- Note that the relays connected are wired to close when the GPIO pin is low. 
   -- This way they don't activate when the chip is reset and the GPIO pins are in input mode.
   if pin==1 then 
     gpio.write(Relay_steam_pin, gpio.LOW)
     gpio.write(Relay_common_pin, gpio.LOW)
     timeout=1200
   elseif pin==2 then
     gpio.write(Relay_common_pin, gpio.LOW)
     gpio.write(Relay_steam_pin, gpio.HIGH)
     timeout=1200
   else
     gpio.write(Relay_steam_pin, gpio.HIGH)
     gpio.write(Relay_common_pin, gpio.HIGH)
   end

   -- Send back JSON response.
   connection:send("HTTP/1.0 200 OK\r\nContent-Type: application/json\r\nCache-Control: private, no-store\r\n\r\n")
   connection:send('{"error":0, "message":"OK"}')

end

return function (connection, req, args)
	Relay_stat = "off"
	if gpio.read(Relay_common_pin) == 0 or gpio.read(Input_heat_pin) == 0 then Relay_stat="heat" end
	if gpio.read(Relay_steam_pin) == 0 then Relay_stat="steam" end
	if gpio.read(Input_ready_pin) == 1 then Relay_stat="ready" end
	
   if not args.Switch == "0" then print('Machine button was pressed!', args.Switch) end
   
   if     args.Switch == "0" then 
   	if (timeout > 0) and not(Relay_stat=="off") then
   		connection:send('<p id="temp"> <span> Temperature: ' .. getTemp() .. ' <br />  Heater off in: ' .. timeout .. ' s' .. '</span> </p>')
   	else
   		connection:send('<p id="temp"> <span>' .. getTemp() .. '</span> </p>')
   	end
   	
   	-- connection:send(' <script> document.getElementById("status").className = "' .. Relay_stat .. '";  </script>')
   	connection:send('<div id="status" class=' .. Relay_stat .. '></div>')

   elseif args.Switch == "1" then pushTheButton(connection, 1)   -- GPIO0 and GPIO2 on
   elseif args.Switch == "2" then pushTheButton(connection, 2)   -- GPIO2 only
   elseif args.Switch == "3" then pushTheButton(connection, 0)   -- all off
   
   else
      connection:send("HTTP/1.0 400 OK\r\nContent-Type: application/json\r\nCache-Control: private, no-store\r\n\r\n")
      connection:send('{"error":-1, "message":"Bad Switch"}')
   end
end
